package uk.ac.bbsrc.babraham.SparkSpotter;
/*
 * SparkSpotter - An ImageJ plugin for finding bright sparks in movies
 * Copyright (c) 2007 Simon Andrews

 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

import javax.swing.JFrame;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.io.File;
import java.io.IOException;
import java.net.URL;

import javax.swing.BorderFactory;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;

public class HelpDialog extends JFrame implements HyperlinkListener{
	
	public JEditorPane htmlPane;

	public HelpDialog (Component c) throws IOException {
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setTitle("SparkSpotter Help...");

		// This is probably going to break.  I can't find the proper way to
		// locate this file automatically as the ImageJ plugin architecture
		// does something funky which breaks ClassLoader.
		File f = new File("plugins/SparkSpotter/sparkspotter_help.html");
		htmlPane = new HelpEditor(f.toURI().toURL());
		htmlPane.setBorder(BorderFactory.createEmptyBorder(15, 15, 15, 15));
		htmlPane.setEditable(false);
		htmlPane.addHyperlinkListener(this);

		setContentPane(new JScrollPane(htmlPane));
		setSize(640,480);
		setLocationRelativeTo(null);
		setVisible(true);
	}
	    
	private class HelpEditor extends JEditorPane {
		public HelpEditor (URL u) throws IOException {
			super(u);
		}
		public void paint(Graphics g) {
			Graphics2D g2 = (Graphics2D)g;
			g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
			
			super.paint(g);
		}
	}

	public void hyperlinkUpdate(HyperlinkEvent h) {
		if (h.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
			try {
				htmlPane.setPage(h.getURL());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	public static void main (String [] args) {
		try {
			new HelpDialog(null);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}

